import { Page, HTTPRequest, HTTPResponse, BrowserLaunchArgumentOptions, PuppeteerNode } from "puppeteer";
export type ProxySettings = {
    proxy?: string;
    proxyCredentials?: {
        username: string;
        password: string;
    };
};
export type InitOptions = BrowserLaunchArgumentOptions & ProxySettings;
export type Action = (page: Page) => Promise<any>;
export type OnComplete = (data: any, errors?: any) => void;
export type OnSuccess = (data: any) => void;
export type OnError = (error: any) => void;
export type OnRequest = (request: HTTPRequest) => void;
export type OnResponse = (response: HTTPResponse) => void;
export interface RunScraper {
    (params: {
        puppeteerPackage?: PuppeteerNode | any;
        initOptions: InitOptions;
        actions: Action[];
        onComplete?: OnComplete;
        onSuccess?: OnSuccess;
        onError?: OnError;
        onRequest?: OnRequest;
        onResponse?: OnResponse;
        timeout?: number;
        retries?: number;
        delayBetweenActions?: number;
    }): Promise<{
        data: any;
        isComplete: boolean;
        errors: any;
        actions: any;
    }>;
}
